 #include <stdio.h>
 #include <wchar.h>
 #include <locale.h>
 #include <string.h>
 #include <stdlib.h>
 #include "buffer.h"

 void printHelp();

 int main()
 {
   wchar_t input[200];
   wchar_t command[100];
   wchar_t arg[100];
   buffer bb; 
   wchar_t * sDisplay;
   *command = L'\0'; 
   *arg = L'\0'; 

   setlocale(LC_ALL, "");
   wprintf(L"Locale is: %s\n", setlocale(LC_ALL,NULL));
   wprintf(L"Test program for the 'buffer' type\n");
   printHelp();
   createBuffer(&bb);

   while(1)
   {
     wprintf(L">");

     command[0] = L'\0';
     arg[0] = L'\0';

     fgetws(input, 200, stdin);
     swscanf(input, L"%ls %ls", command, arg);
     //wprintf(L"command=%ls, arg=%ls \n", command, arg);
     if (wcscmp(command, L"q") == 0)
       { exit(0); }
     else if (wcscmp(command, L"h") == 0)
       { printHelp(); }
     else if (wcscmp(command, L"d") == 0)
     {
       clearWorkspace(&bb); 
       sDisplay = printBuffer(sDisplay, &bb);
       wprintf(L"%ls\n", sDisplay);
     }
     else if (wcscmp(command, L"s") == 0)
     { 
       sDisplay = printBuffer(sDisplay, &bb);
       wprintf(L"%ls\n", sDisplay);
     }
     else if (wcscmp(command, L"S") == 0)
     {
       sDisplay = dumpBuffer(sDisplay, &bb);
       wprintf(L"%ls\n", sDisplay);
     }
     else if (wcscmp(command, L"a") == TRUE)
     {
       if (arg[0] == L'\0')
        { wprintf(L"missing argument\n"); continue; }

       appendText(&bb, arg);
       sDisplay = printBuffer(sDisplay, &bb);
       wprintf(L"%ls\n", sDisplay);
     }
     else if (wcscmp(command, L"p") == TRUE)
     {
       popBuffer(&bb);
       sDisplay = printBuffer(sDisplay, &bb);
       wprintf(L"%ls\n", sDisplay);
     }
     else if (wcscmp(command, L"P") == TRUE)
     {
       pushBuffer(&bb);
       sDisplay = printBuffer(sDisplay, &bb);
       wprintf(L"%ls\n", sDisplay);
     }
     else
     { 
       wprintf(L"unknown command '%ls'\n", command);
       printHelp();
     }
   }

   free(sDisplay);
   free(&bb);
   return 0;
 }

 void printHelp()
 {
   wprintf(
     L" Commands for the 'buffer' test program: \n"
     L" h - print this help message \n"
     L" d - clearBuffer() \n"
     L" a - appendText() \n"
     L" p - popBuffer() \n"
     L" P - pushBuffer() \n"
     L" s - printBuffer() \n"
     L" S - dumpBuffer() \n"
     L" q - exit \n");
 }

