
#include <stdio.h>
#include <locale.h>
#include <wchar.h>
#include "command.h"


/* -------------------------------------------*/
int commandFromString(wchar_t * sCommand)
{
  (wcscmp(sCommand, L"add") == TRUE) && (return ADD); 
  //(wcscmp(sCommand, L"a") == TRUE) && return ADD; 

  if (wcscmp(sCommand, L"add") == 0) { return ADD; }
  else if (wcscmp(sCommand, L"clear") == 0) { return CLEAR; }
  else if (wcscmp(sCommand, L"crash") == 0) { return CRASH; }
  else if (wcscmp(sCommand, L"print") == 0) { return PRINT; }
  else if (wcscmp(sCommand, L"dump") == 0) { return DUMP; }
  else if (wcscmp(sCommand, L"burp") == 0) { return BURP; }
  else if (wcscmp(sCommand, L"tape") == 0) { return TAPE; }
  else if (wcscmp(sCommand, L"escape") == 0) { return ESCAPE; }
  else if (wcscmp(sCommand, L"time") == 0) { return TIME; }
  else if (wcscmp(sCommand, L"replace") == 0) { return REPLACE; }
  else if (wcscmp(sCommand, L"indent") == 0) { return INDENT; }
  else if (wcscmp(sCommand, L"clip") == 0) { return CLIP; }
  else if (wcscmp(sCommand, L"clop") == 0) { return CLOP; }
  else if (wcscmp(sCommand, L"newline") == 0) { return NEWLINE; }
  else if (wcscmp(sCommand, L"push") == 0) { return PUSH; }
  else if (wcscmp(sCommand, L"pop") == 0) { return POP; }
  else if (wcscmp(sCommand, L"put") == 0) { return PUT; }
  else if (wcscmp(sCommand, L"get") == 0) { return GET; }
  else if (wcscmp(sCommand, L"++") == 0) { return INCREMENT; }
  else if (wcscmp(sCommand, L"--") == 0) { return DECREMENT; }
  else if (wcscmp(sCommand, L"read") == 0) { return READ; }
  else if (wcscmp(sCommand, L"until") == 0) { return UNTIL; }
  else if (wcscmp(sCommand, L"while") == 0) { return WHILE; }
  else if (wcscmp(sCommand, L"whilenot") == 0) { return WHILENOT; }
  else if (wcscmp(sCommand, L"count") == 0) { return COUNT; }
  else if (wcscmp(sCommand, L"plus") == 0) { return INCC; }
  else if (wcscmp(sCommand, L"minus") == 0) { return DECC; }
  else if (wcscmp(sCommand, L"jump") == 0) { return JUMP; }
  else if (wcscmp(sCommand, L"check") == 0) { return CHECK; }
  else if (wcscmp(sCommand, L"@@@") == 0) { return LABEL; }
  else if (wcscmp(sCommand, L"zero") == 0) { return ZERO; }
  else if (wcscmp(sCommand, L"nop") == 0) { return NOP; }
  else { return UNKNOWN; }
}

/* ------------------------------------------- */
wchar_t * commandToDisplayText(wchar_t * sReturn, int iCommand)
{
  switch (iCommand)
  {
    case ADD:
      wcscpy(sReturn, L"add"); break;
    case CLEAR:
      wcscpy(sReturn, L"clear"); break;
    case PRINT:
      wcscpy(sReturn, L"print"); break;
    case DUMP:
      wcscpy(sReturn, L"dump"); break;
    case BURP:
      wcscpy(sReturn, L"burp"); break;
    case TIME:
      wcscpy(sReturn, L"time"); break;
    case REPLACE:
      //--unimplemented command
      break;
    case INDENT:
      wcscpy(sReturn, L"indent"); break;
    case CLIP:
      wcscpy(sReturn, L"clip"); break;
    case CLOP:
      wcscpy(sReturn, L"clop"); break;
    case NEWLINE:
      wcscpy(sReturn, L"newline"); break;
    case PUSH:
      wcscpy(sReturn, L"push"); break;
    case POP:
      wcscpy(sReturn, L"pop"); break;
    case PUT:
      wcscpy(sReturn, L"put"); break;
    case GET: 
      wcscpy(sReturn, L"get"); break;
    case COUNT:
      wcscpy(sReturn, L"count"); break;
    case INCREMENT:
      wcscpy(sReturn, L"++"); break;
    case DECREMENT:
      wcscpy(sReturn, L"--"); break;
    case READ:   
      wcscpy(sReturn, L"read"); break;
    case UNTIL:
      wcscpy(sReturn, L"until"); break;
    case WHILE:
      wcscpy(sReturn, L"while"); break;
    case WHILENOT:
      //unimplemented command
      //wcscpy(sReturn, L"whilenot");
      wcscpy(sReturn, L"");
      break;
    case TESTIS:
      wcscpy(sReturn, L"/text/"); break;
    case TESTBEGINS:
      wcscpy(sReturn, L"<text>"); break;
    case TESTENDS:
      wcscpy(sReturn, L"(text)"); break;
    case TESTCLASS:
      wcscpy(sReturn, L"[text]"); break;
    case TESTLIST:
      wcscpy(sReturn, L"=text="); break;
    case TESTEOF:
      wcscpy(sReturn, L"<>"); break;
    case TESTTAPE:
      wcscpy(sReturn, L"=="); break;
    case INCC:   
      wcscpy(sReturn, L"plus"); break;
    case DECC:
      wcscpy(sReturn, L"minus"); break;
    case CRASH:
      wcscpy(sReturn, L"crash"); break;
    case JUMP:
      wcscpy(sReturn, L"jump"); break;
    case CHECK:
      wcscpy(sReturn, L"check"); break;
    case LABEL:
      wcscpy(sReturn, L"@@@"); break;
    case NOP:     /* no operation */
      wcscpy(sReturn, L"nop"); break;
    case ZERO:     /*  */
      wcscpy(sReturn, L"zero"); break;
    case OPENBRACE:
      wcscpy(sReturn, L"{"); break;
    case CLOSEBRACE:
      wcscpy(sReturn, L"}"); break;
    default:
      wcscpy(sReturn, L"unknown command"); break;

  } /* switch */
  return sReturn;

}

/* -------------------------------------------*/
wchar_t * commandToLongText(wchar_t * sReturn, int iCommand)
{
  switch (iCommand)
  {
    case ADD:
      wcscpy(sReturn, L"add"); break;
    case CLEAR:
      wcscpy(sReturn, L"clear"); break;
    case PRINT:
      wcscpy(sReturn, L"print"); break;
    case DUMP:
      wcscpy(sReturn, L"dump"); break;
    case TAPE:
      wcscpy(sReturn, L"tape"); break;
    case BURP:
      wcscpy(sReturn, L"burp"); break;
    case ESCAPE:
      wcscpy(sReturn, L"escape"); break;
    case TIME:
      wcscpy(sReturn, L"time"); break;
    case REPLACE:
      wcscpy(sReturn, L"replace"); break;
    case INDENT:
      wcscpy(sReturn, L"indent"); break;
    case CLIP:
      wcscpy(sReturn, L"clip"); break;
    case CLOP:
      wcscpy(sReturn, L"clop"); break;
    case NEWLINE:
      wcscpy(sReturn, L"newline"); break;
    case PUSH:
      wcscpy(sReturn, L"push"); break;
    case POP:
      wcscpy(sReturn, L"pop"); break;
    case PUT:
      wcscpy(sReturn, L"put"); break;
    case GET: 
      wcscpy(sReturn, L"get"); break;
    case COUNT:
      wcscpy(sReturn, L"count"); break;
    case INCREMENT:
      wcscpy(sReturn, L"++"); break;
    case DECREMENT:
      wcscpy(sReturn, L"--"); break;
    case READ: 
      wcscpy(sReturn, L"read"); break;
    case UNTIL:
      wcscpy(sReturn, L"until"); break;
    case WHILE:
      wcscpy(sReturn, L"while"); break;
    case WHILENOT:
      wcscpy(sReturn, L"while-not"); break;
    case TESTIS:
      wcscpy(sReturn, L"testis"); break;
    case TESTBEGINS: 
      wcscpy(sReturn, L"testbeginswith"); break;
    case TESTENDS:
      wcscpy(sReturn, L"testendswith"); break;
    case TESTCLASS:
      wcscpy(sReturn, L"testclass"); break;
    case TESTLIST:
      wcscpy(sReturn, L"testlist"); break;
    case TESTEOF:
      wcscpy(sReturn, L"testeof"); break;
    case TESTTAPE:
      wcscpy(sReturn, L"testtape"); break;
    case INCC:   
      wcscpy(sReturn, L"plus"); break;
    case DECC:
      wcscpy(sReturn, L"minus"); break;
    case CRASH:
      wcscpy(sReturn, L"crash"); break;
    case UNDEFINED:
      wcscpy(sReturn, L"undefined"); break;
    case JUMP:
      wcscpy(sReturn, L"jump"); break;
    case CHECK:
      wcscpy(sReturn, L"check"); break;
    case LABEL:
      wcscpy(sReturn, L"label"); break;
    case NOP:     
      wcscpy(sReturn, L"nop"); break;
    case ZERO:   
      wcscpy(sReturn, L"zero"); break;
    case OPENBRACE:
      wcscpy(sReturn, L"open-brace"); break;
    case CLOSEBRACE:
      wcscpy(sReturn, L"close-brace"); break;
    default:
      wcscpy(sReturn, L"unknown command"); break;
  } /* switch */
  return sReturn;
}

/*--------------------------------------------*/
/* prints a compact summary of legal commands */

void showCommands(int iWidth)
{
  wchar_t sCommand[100];
  int iCommand;
  wcscpy(sCommand, L"");

  wprintf(L"legal commands: \n");

  for (iCommand = 1; iCommand < UNDEFINED; iCommand++)
  {
    commandToDisplayText(sCommand, iCommand);   
    wprintf(L"%ls", sCommand);
    if (iCommand % iWidth == 0) 
     { wprintf("\n"); }
  }

  printf("\n");
  //printf("* All commands except tests and braces must end with ';' \n");
  //printf("* All statement blocks must be enclosed in {} \n");
}
