#ifndef COMMAND_H
#define COMMAND_H

  #define TRUE 0
  #define FALSE 1


   enum commandtype
   { ADD = 1,              /* adds a given text to the workbuffer */
     CLEAR,                /* clears the workspace */
     PRINT,                /* prints the workspace to stdout */
     DUMP,                 /* prints the current state of the machine */
     TAPE,                 /* prints all tape elements and stack */
     BURP,                 /* prints a very detailed dump of the machine */ 
     ESCAPE,               /* turns escape sequences in the workspace to chars */
     REPLACE,     /* ??? unimplemened ???  */
     INDENT,      /* indents each line of the workspace */
     CLIP,        /* removes the last character of the workspace */
     CLOP,        /* removes the first character of the workspace */
     NEWLINE,     /* adds a newline to the  workspace */
     PUSH,        /* pushes the next token in the  workspace onto the stack */
     POP,         /* pops the next token onto the workspace */
     PUT,         /* put the contents of the workspace in the tape */
     GET,         /* adds the current tape element to the workspace */
     SWAP,        /* swaps the current tape element with the workspace */
     INCREMENT,   /* increases the tape pointer by one */
     DECREMENT,   /* decreases the tape pointer by one */
     READ,        /* read one (wide) character from the input stream */
     UNTIL,       /* read the input stream until the workspace ends with ... */
     WHILE,       /* read the input stream while the 'peep' is ... */
     WHILENOT,    /* ??? unimplemented ??? */
     TESTIS,
     TESTBEGINS,
     TESTCLASS,
     TESTENDS,
     TESTLIST,
     TESTEOF,
     TESTTAPE,
     TIME,           /* adds the amount of time the machine has run */
     COUNT,      
     INCC,           /* increment the accumulator or counter */
     DECC,           /* decrement the accumulator or counter */
     CRASH,          /* exits the script immediately */
     OPENBRACE,      /* does nothing, for calculating jumps */
     CLOSEBRACE,     /* does nothing, for calculating jumps */
     ZERO,           /* sets the accumulator to zero */
     JUMP,           /* an unconditional jump to a line number */
     CHECK,          /* ??? a shift reduce jump, remove ??? */
     LABEL,          /* todo: reassess this */
     NOP,                          /* no operation */
     UNDEFINED,                    /* the default */
     UNKNOWN
   };

    wchar_t * printCommands(int iWidth);
    wchar_t * showCommands(wchar_t * sReturn, int iCommand);

#endif
